
import TempConvertApp.*;
import org.omg.CosNaming.*;
import org.omg.CosNaming.NamingContextPackage.*;
import org.omg.CORBA.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

public class ConvertClient extends JFrame {

    static Convert convertImpl;
    static JTextField input;
    static JTextField output;
    static ConvertClient a;
    static JButton submit, clear;

    public ConvertClient() { //layout the GUI
        Container contentPane = getContentPane();
        contentPane.setLayout(new FlowLayout());
        JLabel l1 = new JLabel("C input:");
        JLabel l2 = new JLabel("F output");
        input = new JTextField(10);
        output = new JTextField(10);
        submit = new JButton("SUBMIT");
        clear = new JButton("Clear");
        submit.addActionListener(new ActionHandler());
        clear.addActionListener(new ActionHandler());
        contentPane.add(l1);
        contentPane.add(input);
        contentPane.add(l2);
        contentPane.add(output);
        contentPane.add(submit);
        contentPane.add(clear);
        setTitle("Client Access");
        setSize(540, 250);
        show();
    }

    public static void main(String args[]) {
        try {
            a = new ConvertClient();
// create and initialize the ORB
            ORB orb = ORB.init(args, null);
// get the root naming context
            org.omg.CORBA.Object objRef =
                    orb.resolve_initial_references("NameService");
// Use NamingContextExt instead of NamingContext.
// This is part of the Interoperable naming Service.
            NamingContextExt ncRef = NamingContextExtHelper.narrow(objRef); // resolve the Object Reference in Naming

            String name = "Convert";
            convertImpl = ConvertHelper.narrow(ncRef.resolve_str(name));
        } catch (Exception e) {
            System.out.println("ERROR : " + e);
            e.printStackTrace(System.out);
        }
    }

    class ActionHandler implements ActionListener {

        public void actionPerformed(ActionEvent e) {
            try {
                if (e.getSource() == submit) {
                    System.out.println("Obtained a handle on server object:");
                    String temp = input.getText();
                    double a = Double.parseDouble(temp);
                    double result = convertImpl.cToF(a);
                    output.setText("" + result);
                } else if (e.getSource() == clear) {
                    input.setText("");
                    output.setText("");
                }
            } catch (Exception ex) {
                System.out.println("ERROR : " + e);
                ex.printStackTrace(System.out);
            }
        }
    }
}
