// ConvertServer.java
import TempConvertApp.*;
import org.omg.CosNaming.*;
import org.omg.CosNaming.NamingContextPackage.*;
import org.omg.CORBA.*;
import org.omg.PortableServer.*;
import java.util.Properties;

class ConvertImpl extends ConvertPOA {

    private ORB orb;

    public void setORB(ORB orb_val) {
        orb = orb_val;
    }
// implement cToF() method

    public double cToF(double c) {
        return (c * 9. / 5 + 32);
    }
}

public class ConvertServer {

    public static void main(String args[]) {
        try {
// create and initialize the ORB
            ORB orb = ORB.init(args, null);
// get reference to rootpoa & activate the POAManager
            POA rootpoa =
                    POAHelper.narrow(orb.resolve_initial_references("RootPOA"));
            rootpoa.the_POAManager().activate();
// create servant and register it with the ORB
            ConvertImpl convertImpl = new ConvertImpl();
            convertImpl.setORB(orb);
//get object reference from servant
            org.omg.CORBA.Object ref =
                    rootpoa.servant_to_reference(convertImpl);
            Convert href = ConvertHelper.narrow(ref);
//get naming context
            org.omg.CORBA.Object objRef =
                    orb.resolve_initial_references("NameService");
// cast the generic object reference to a proper type
            NamingContextExt ncRef =
                    NamingContextExtHelper.narrow(objRef);
//bind the name “Convert” with naming service
            NameComponent path[] = ncRef.to_name("Convert");
            ncRef.rebind(
                    path,
                    href);
// wait for invocations from client
            orb.run();
        } catch (Exception ex) {
            System.err.println("ERROR: " + ex);
            ex.printStackTrace(System.out);
        }
    }
}
